/*

This program writes the GetPreviousPrime function to a SmartDongle using the demo keys.

Copyright 2010 MicroWorks, Inc.

MicroWorks, Inc.
2808 North Cole Road
Boise, ID 83704
*/
#include <objbase.h>
#include <windows.h>
#include <setupapi.h>
#include <stdlib.h>
#include <time.h>
#include <ctype.h>

#include <stdio.h>
#include <stdlib.h>
#include "smartdongle.h"
#include "devioctl.h"
#include "usb100.h"
#include "sd_cy7c63743.h"
#include "sd_cp2.h"
#include "sd_user.h"
#include "sd_eeprom.h"
#include "sd_uskerr.h"
#include "sd_helper.h"

unsigned int GetPreviousPrime(unsigned int iParm)
{
	unsigned int iNextTry;
	unsigned int iDivisor;
	unsigned int iQuotient;

	if (iParm == 3)
		return 2;

	if (iParm < 3)
		return (0);

	if (iParm & 1)
	{ //If this is an odd number start with the next previous number
		iNextTry = iParm-2;
	}
	else
	{ // subtract 1 from even numbers
		iNextTry = iParm-1;
	}

	if (iNextTry < 3)
		return (0);

	for (; iNextTry > 2; iNextTry-=2)
	{
		for (iDivisor =3; ; iDivisor+=2)
		{
			iQuotient = iNextTry / iDivisor;
			if (iQuotient < iDivisor)
			{
				return (iNextTry);
			}
			if (iQuotient * iDivisor == iNextTry)
			{ // iNextTry not a prime, try next value
				break;
			}
		}
	}
	// Something bad happened.  There were no primes smaller than the starting value
	return (0);
}

int __cdecl main(int argc, char* argv[])
{
	char * pAddress = (char *)&GetPreviousPrime;
	int error;
	unsigned __int64 P1, P2;
	unsigned int iParm;
	unsigned int iReturn;
	unsigned int iSize = 75; 

	if (argc != 1)                                       
	{
		printf ("Usage:  WriteFunction\n");
		return (1);
	}

	iParm = 0;
	iReturn = GetPreviousPrime(iParm);
	SmartDongleLedOff();
	SmartDongleLedRed();
	SmartDongleLedGreen();
	P1 = 0xec6cc589aefd1e75;
	P2 = 0xfcec0a6a82747b3f;

	// Write the size of the function to the SmartDongle
	error = SmartDongleWrite(P1, P2, 0, (char *)&iSize, 4);
	if (error)
	{
		error = error;
	}
	// Write the function to the SmartDongle
	error = SmartDongleWrite(P1, P2, 4, (char *)&GetPreviousPrime, iSize);
	if (error)
	{
		error = error;
	}
	SmartDongleLedGreen();
	return 0;
}
